/**
 * Behaviour of the project files page
 * 
 * @author Christophe Lauret
 * @version 3 September 2010
 */

// Declare all global dependencies for JSLint
/*global PAGESEEDER, $ */

// Defines and invokes an anonymous function to create a closure.
$(document).ready(function() {

  var lightbox = function(content, title, aclass, after, buttons) {
    // just in case
    $('#alert-lightbox').foundation('reveal', 'close');
    // is there a class?
    if (typeof(aclass) == 'function' && !buttons) {
      buttons = after;
      after = aclass;
      aclass = 'tiny';
    }
    var myclass = !!aclass ? ' '+aclass : '';
    var mybuttons = !buttons ? '<button class="button radius primary close">close</button>' : buttons;
    var myid = new Date().getTime();
    var $lightbox = $('<div id="alert-lightbox" class="lightbox reveal-modal'+myclass+'" data-reveal="'+myid+'" aria-hidden="true" role="dialog">'+
        '<div class="row inner">'+
        '  <div class="small-10 columns"><h1></h1></div>'+
        '  <div class="small-2  columns text-right"><a class="close-reveal-modal" aria-label="Close" href="#">&#215;</a></div>'+
        '</div>'+
        '<div class="row inner"><div class="small-12 columns content"></div></div>'+
        '<div class="row inner"><div class="small-12 columns ps-buttons text-center">'+mybuttons+'</div></div>'+
      '</div>');
    // used to handle chrome bug
    $lightbox.css('top', '100px');
    // after closing the alert dialog
    if (!!after) { $(document).on('closed.fndtn.reveal', '#alert-lightbox[data-reveal="'+myid+'"]', after); }
    $lightbox.find('h1').html(title);
    // is it a jquery object?
    if (content[0]) {
      $lightbox.find('.content').html('').append(content);
    } else {
      $lightbox.find('.content').html(!content ? '' : content.startsWith('<') ? content : '<p>'+content+'</p>');
    }
    // close button
    $lightbox.find('.ps-buttons button.close').on('click', function() {
      $lightbox.foundation('reveal', 'close');
      if (!!after) { after($lightbox); }
      return false;
    });
    $lightbox.foundation('reveal', 'open');
    return $lightbox;
  };

  var confirmLightbox = function(content, title, aclass, success) {
    // is there a class?
    if (typeof(aclass) == 'function' && !success) {
      success = aclass;
      aclass = 'tiny';
    }
    var buttons = '<button class="button radius primary ok">Yes</button>' +
                  '<button class="button radius secondary close">No</button>';
    var $box = lightbox(content, title, aclass, null, buttons);
    $box.find('button.ok').click(function() {
      if (!!success) { success($box); }
      return false;
    });
    return $box;
  };

  var errorLightbox = function(content, title) {
    return lightbox(!content ? 'An error occurred.' : content, !title ? 'Error' : title, 'error tiny');
  };

  $.pspublisher = {
      dialog  : lightbox,
      error   : errorLightbox,
      confirm : confirmLightbox
  };

  // close button on any lightbox
  $('.reveal-modal').on('click', '.ps-buttons button.close', function() {
    $(this).parents('.reveal-modal').foundation('reveal', 'close');
    return false;
  });
  // focus on first input if there's a form in a loghtbox
  $(document).on('opened.fndtn.reveal', '[data-reveal]', function () {
    $(this).find('form input:first').focus();
  });
  
});
